(define-module (alterator lookout new-mapper)
	       :use-module (alterator object)
	       :use-module (alterator lookout context)
	       :export (make-file-item
			 make-view-item
			 make-mapper
			 load-mapper

			 with-mapper))

;TODO: MAPPER-VIEW-ALL
(define-macro (with-mapper <mapper> <instruction> . <instructions>)
    `(with-changed-context 'mapper ,<mapper> ,<instruction> . ,<instructions>))

;file mapper item
(define (make-file-item file-name params)
  (object
    (lambda other-params
      (make-file-item file-name (append params other-params)))
    ((name self) file-name)
    ((params self) params)))

;view mapper item
(define (make-view-item mappings next-url params)
  (object
    (lambda other-params
      (cond
	((assq next-url mappings) => (lambda (item)
				       (apply (cdr item) params)))
	(else #f)))))

(define (a-append alist name value)
  (append alist (list (cons name value))))

;mapper itself
(define (make-mapper mappings)
  (define-operation get-maps)
  (define-operation join-maps)
  
  (object
    (lambda (url . params)
      (cond
	((assq url mappings) => (lambda (item)
				  (apply (cdr item) params)))
	(else #f)))
    ((file self url file-name params)
     (make-mapper (a-append mappings url (make-file-item file-name params))))
    ((view self url next-url params)
     (make-mapper (a-append mappings url (make-view-item mappings next-url params))))
    ((get-maps self) mappings)
    ((join-maps self mapper) (make-mapper (append mappings (get-maps mapper))))

    ((include self filespec)
     (define-operation get-maps)
     (fold
       (lambda (file-name mapper)
	 (join-maps mapper (load-mapper file-name)))
       self
       (glob filespec)))))

(define (load-mapper file-name)
  (format #t "loading from file~%")
  (make-mapper '( (/ . "hehe.scm"))))

